--self.Vel.Y/100 - mode
--self.Vel.X - shield (mode 3) power
--self.Mass - power/focus

function CreateIndicators (self,targetMO)
	if MovableMan:ValidMO(targetMO) and (targetMO~=nil) then
		self.ModeIndicatorOffset = Vector(23, -43);
		self.ModeIndicator = CreateMOSParticle("BindweedModeIndicator");
		self.ModeIndicator.Pos = targetMO.Pos + self.ModeIndicatorOffset;
		self.ModeIndicator.Frame = 0;
		
		self.PowerIndicatorOffset = Vector(9, -35);
		self.PowerIndicator = CreateMOSParticle("BindweedPowerIndicator");
		self.PowerIndicator.Pos = targetMO.Pos + self.ModeIndicatorOffset;
		self.PowerIndicator.Frame = 0;
		
		MovableMan:AddParticle(self.ModeIndicator);
		MovableMan:AddParticle(self.PowerIndicator);
	end
end

function SelfKeepAliveAndWell (self) --Controls states of internal variables, position, etc.
	self.Mass=self.Power/100;
	self:NotResting();	
	self.Age = 0;
	self.ToSettle = false;		
	
	self.mode=math.ceil(self.Vel.Y*100);
	self.Vel.Y =self.mode/100;  --in theory it must prevent velocity from decaying (and resetting mode as a result)
	--print(MovableMan:ValidMO(self.gun));
	--print(MovableMan:ValidMO(self.origin));
	--print(MovableMan:ValidMO(self.PowerIndicator));
	--print(MovableMan:ValidMO(self.ModeIndicator));
	if (MovableMan:ValidMO(self.origin)==false) then
		if (MovableMan:ValidMO(self.gun)==false) then
			self.Pos=self.Pos;
			--print("no host");
			--print(self.Pos);
		else
			self.Pos=self.gun.Pos;
			--print("binded to gun");
			--print(self.Pos);
		end
	else
		self.Pos=self.origin.Pos;
		--print("binded to actor");
		--print(self.Pos);
	end
end

function BindToAHuman (self,gun_name) --Binds controller to nearest AHuman with Bindweed in its inventory
	local curdist = 50;
	local result=false;
	for actor in MovableMan.Actors do
		if (actor.ClassName == "AHuman") and actor:HasObject(gun_name) then
			local Dist=SceneMan:ShortestDistance(actor.Pos,self.Pos,true);
			if Dist.Magnitude < curdist then
				curdist = Dist.Magnitude;
				self.origin = actor;
				self.Pos = actor.Pos;
				self.WeaponInHand = true;
				self.gun = nil;
				result = true;
				--print("bind to:");
				--print(self.origin);
			end
		end
	end
	return result;
end

function BindToHDFirearm (self,gun_name) --Binds controller to nearest Bindweed item
	local curdist = 100;
	local result=false;
	for item in MovableMan.Items do
		if (item.ClassName == "HDFirearm") and (item.PresetName == gun_name) then
			local Dist=SceneMan:ShortestDistance(item.Pos,self.Pos,true);
			if Dist.Magnitude < curdist then
				curdist = Dist.Magnitude;
				self.gun = item;
				self.Pos = self.gun.Pos;
				self.origin = nil;
				result = true;
				self.WeaponInHand = false;
				--print("bind to:");
				--print(self.gun);
			end
		end
	end
	return result;
end
	
function Create(self)
	--print("created");
	self.count=0;
	self.Mass=0.5;
	self.binded=false;
	self.Power=50;
	self.ShowSettings=false;
	self.NoWeaponTimer=0;
	self.mode=1;
	self.LastGoodMode=1;
	self.Vel.X=0.01;
	self.Vel.Y=0.01;

	local partcurdist = 40;
	for pix in MovableMan.Particles do
		if pix.ClassName == "MOSRotating" and (pix.PresetName=="BindweedController") then
			local Dist=SceneMan:ShortestDistance(pix.Pos,self.Pos,true);
			if (Dist.Magnitude < partcurdist) then
				self.count=self.count+1;
			end
		end
	end
	if self.count==1 then
		if BindToAHuman(self,"ISME Bindweed")==false then
			if BindToHDFirearm(self,"ISME Bindweed")==false then
				self.ToDelete = true;
			else
				CreateIndicators (self,self.gun);
			end
		else
			CreateIndicators (self,self.origin);
		end
	else
		self.ToDelete = true;
	end
end
 
function Update(self)
	if (MovableMan:ValidMO(self.origin)==false) and (MovableMan:ValidMO(self.gun)==false) and (self.ToDelete==false) then
		if BindToAHuman(self,"ISME Bindweed")==false then
			if BindToHDFirearm(self,"ISME Bindweed")==false then
				--if self.selfdestructiontime~=0 then
						--self.ToDelete=true;
				--end
			else
				CreateIndicators (self,self.gun);
			end
		else
			CreateIndicators (self,self.origin);
		end
	end
	if (MovableMan:ValidMO(self.origin)==true) and (MovableMan:ValidMO(self.gun)==false) then
		SelfKeepAliveAndWell(self);
		self.origin:GetController():SetState(Controller.WEAPON_CHANGE_NEXT,false);
		self.origin:GetController():SetState(Controller.WEAPON_CHANGE_PREV,false);
		if (self.origin:GetController():IsState(Controller.SCROLL_UP)==true) and (self.Power<100) then
			self.Power=self.Power+5;
		end
		if (self.origin:GetController():IsState(Controller.SCROLL_DOWN)==true) and (self.Power>0) then
			self.Power=self.Power-5;
		end
		if (self.origin:GetController():IsState(Controller.PIE_MENU_ACTIVE)==true) or (self.origin:GetController():IsState(Controller.WEAPON_CHANGE_NEXT)==true) or (self.origin:GetController():IsState(Controller.WEAPON_CHANGE_PREV)==true) or (self.origin:GetController():IsState(Controller.WEAPON_PICKUP)==true) or (self.origin:GetController():IsState(Controller.WEAPON_DROP)==true) then
			self.WeaponInHand=false;
			self.NoWeaponTimer=self.Age;
		end
		
		self.ModeIndicator.Pos = self.origin.Pos + self.ModeIndicatorOffset;
		self.PowerIndicator.Pos = self.origin.Pos + self.PowerIndicatorOffset;
		if self.WeaponInHand==true then
			self.PowerIndicator.Frame = self.Power/5+1;
			if (self.mode<10) then
				self.ModeIndicator.Frame = self.mode;
			else
				self.Power=math.random(100);
				self.ModeIndicator.Frame = 4;
			end
		else
			self.ModeIndicator.Frame = 0;
			self.PowerIndicator.Frame = 0;
		end
		self.ModeIndicator:NotResting();	
		self.ModeIndicator.Age = 0;
		self.ModeIndicator.ToSettle = false;
			
		self.PowerIndicator:NotResting();	
		self.PowerIndicator.Age = 0;
		self.PowerIndicator.ToSettle = false;
		
		--if self.ShowSettings==true and (MovableMan:ValidMO(self.BindweedSettingsPointer)==true) and (MovableMan:ValidMO(self.BindweedSettingsBracket)==true) then
		--if (MovableMan:ValidMO(self.BindweedSettingsBracket)==true) then
			--self.BindweedSettingsPointer.Pos = self.origin.Pos;
			--self.BindweedSettingsPointer.Frame = math.ceil(self.BindweedSettingsPointer.Age/100)%9;
			--self.BindweedSettingsPointer:NotResting();	
			--self.BindweedSettingsPointer.ToSettle = false;
			--if	self.BindweedSettingsPointer.Age>1800 then
			--	self.BindweedSettingsPointer.Age=0;
			--end
			--self.BindweedSettingsBracket.Pos = self.origin.Pos+ self.BracketOffset;
			--self.BindweedSettingsBracket:NotResting();	
			--self.BindweedSettingsBracket.ToSettle = false;
			--self.BindweedSettingsBracket.Age=0;
		--end
			
		if	MovableMan:ValidMO(ActivityMan:GetActivity():GetControlledActor(self.origin.Team))==true then
			if ActivityMan:GetActivity():GetControlledActor(self.origin.Team).ID==self.origin.ID then
				if (UInputMan:KeyHeld(6)==true) and (self.mode<10) then	
					self.Vel.Y=0.02;
				end
				if (UInputMan:KeyHeld(7)==true) and (self.mode<10) then	
					self.Vel.Y=0.01;
				end
				if (UInputMan:KeyHeld(8)==true) and (self.mode<10) then	
					self.Vel.Y=0.03;
				end
				
				--if (UInputMan:KeyHeld(13)==true)  then	
					--if (MovableMan:ValidMO(self.BindweedSettingsPointer)==false) and (MovableMan:ValidMO(self.BindweedSettingsBracket)==false) then
				--	if (MovableMan:ValidMO(self.BindweedSettingsBracket)==false) then
						--self.BindweedSettingsPointer = CreateMOSParticle("BindweedSettingsPointer");
						--self.BindweedSettingsPointer.Pos = self.origin.Pos;
						--MovableMan:AddParticle(self.BindweedSettingsPointer);
						
				--		self.BindweedSettingsBracket = CreateMOSParticle("BindweedSettingsBracket");
				--		MovableMan:AddParticle(self.BindweedSettingsBracket);
				--		self.BracketOffset= Vector(-22, -24);
				--		self.BindweedSettingsBracket.Pos = self.origin.Pos+self.BracketOffset;
				--	end
				--else
					--if (MovableMan:ValidMO(self.BindweedSettingsPointer)==true) and (MovableMan:ValidMO(self.BindweedSettingsBracket)==true) then
				--	if(MovableMan:ValidMO(self.BindweedSettingsBracket)==true) then
						--self.BindweedSettingsPointer.ToDelete = true;
				--		self.BindweedSettingsBracket.ToDelete = true;
				--	end
				--end
			end
		end
			
		if (self.mode==3) and (self.origin:GetController():IsState(Controller.WEAPON_FIRE)==true) then
			local desdist = (30+60*self.Mass);
			for pix in MovableMan.Particles do
				if (pix.PresetName ~= "CompressedPlasmaCell") and (pix.PresetName ~= nil) and (pix.HitsMOs) and (pix.Sharpness>8) then
					local Distance=SceneMan:ShortestDistance(pix.Pos,self.origin.Pos,true);
					if Distance.Magnitude<desdist then
						--if self.Vel.X>0.6 then
						--	pix.Sharpness=pix.Sharpness*0.1; 
						--	pix.Vel=pix.Vel*0.1;
						--	pix.Mass=pix.Mass*0.7;
						--else 
						--	pix.Sharpness=pix.Sharpness*(1-self.Vel.X*1.50); 
						--	pix.Vel=pix.Vel*(1-self.Vel.X*1.50);
						--	pix.Mass=pix.Mass*0.9;
						--end
						pix.Sharpness=pix.Sharpness*(1-self.Vel.X); 
						pix.Vel=pix.Vel*(1-self.Vel.X);
						pix.Mass=pix.Mass*0.9;
						if self.Vel.X>0.02 then
							self.Vel.X=self.Vel.X-0.001;
						end
					end
				end
				-- Reminder: think about instagibbing explosives 
			end
		end
		if self.origin:HasObject("ISME Bindweed") then
			if (self.WeaponInHand==false) and (self.origin:GetController():IsState(Controller.PIE_MENU_ACTIVE)==false) then
				local partcurdist = 20;
				for pix in MovableMan.Particles do
					if (pix.ClassName == "MOPixel") and (pix.PresetName=="BindweedInHandIndicator") then
						local Dist=SceneMan:ShortestDistance(pix.Pos,self.Pos,true);
						if (Dist.Magnitude < partcurdist) then			
							self.WeaponInHand=true;
						end
					end
				end
			end
		else
			self.ModeIndicator.ToDelete = true;
			self.PowerIndicator.ToDelete = true;
			if BindToHDFirearm (self,"ISME Bindweed")== false then
				self.origin=nil;
			else
			end
			--if self.Age-self.NoWeaponTimer>5000 then
			--	self.ToDelete = true;
			--end
		end
	end
	if (MovableMan:ValidMO(self.origin)==false) and (MovableMan:ValidMO(self.gun)==true) then
	SelfKeepAliveAndWell(self);
		if BindToAHuman(self,"ISME Bindweed")==false then
		else
			CreateIndicators (self,self.origin);
		end
	end		
end

function Destroy(self)
--print("destroyed");
	--if	self.ModeIndicator~=nil then
	--	self.ModeIndicator.ToDelete = true;
	--end
	--if	self.PowerIndicator~=nil then
	--	self.PowerIndicator.ToDelete = true;
	--end
end